import TBYDKService from '@/service/tbydk/tbydk-service';
import { Verify } from '@/utils/verify/verify';


/**
 * 获取特别约定库信息
 *
 * @export
 * @class GetTBYDKXXBase
 */
export default class GetTBYDKXXBase {

    /**
     * 名称
     * 
     * @memberof  GetTBYDKXXBase
     */
    private name:string ="GetTBYDKXX";

    /**
     * 唯一标识
     * 
     * @memberof  GetTBYDKXXBase
     */
    private id:string = "c73756bb9370753fb6a072f7eff82194";

    /**
     * 默认参数名称
     * 
     * @memberof  GetTBYDKXXBase
     */
    private defaultParamName:string = "Default";

    /**
     * Creates an instance of  GetTBYDKXXBase.
     * 
     * @param {*} [opts={}]
     * @memberof  GetTBYDKXXBase
     */
    constructor(opts: any = {}) {
        
    }


    /**
     * 计算0节点结果
     * 
     * @param params 传入参数
     */
    public compute0Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算1节点结果
     * 
     * @param params 传入参数
     */
    public compute1Cond(params:any):boolean{
        return true;
    }

    /**
     * 计算2节点结果
     * 
     * @param params 传入参数
     */
    public compute2Cond(params:any):boolean{
        if(Verify.testCond(params.tbydkid, 'ISNOTNULL', '')){
           return true;
        }else{
            return false;
        }
    }

    /**
     * 执行逻辑
     * 
     * @param context 应用上下文
     * @param params 传入参数
     */
    public onExecute(context:any,params:any,isloading:boolean){
        return this.executeBegin(context,params,isloading);
    }


    /**
    * 开始
    * 
    * @param params 传入参数
    */
    private async executeBegin(context:any,params:any,isloading:boolean){
        //开始节点
        if(this.compute1Cond(params)){
            return this.executePrepareparam1(context,params,isloading);   
        }
    }

    /**
    * 获取约定库标识
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam1(context:any,params:any,isloading:boolean){
        // 准备参数节点
        Object.assign(params,{tbydkid:params.tbydkid});
        Object.assign(context,{tbydk:params.tbydkid});
        if(this.compute2Cond(params)){
            return this.executeDeaction1(context,params,isloading);   
        }
    }

    /**
    * 获取特别约定库信息
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executeDeaction1(context:any,params:any,isloading:boolean){
        // 行为处理节点
        let result: any;
        const targetService:TBYDKService = new TBYDKService();
        if (targetService['Get'] && targetService['Get'] instanceof Function) {
            result = await targetService['Get'](context,params, false);
        }
        if(result && result.status == 200){
            Object.assign(params,result.data);
        if(this.compute0Cond(params)){
            return this.executePrepareparam2(context,params,isloading);   
        }
        }
    }

    /**
    * 回填约定库信息
    * 
    * @param context 应用上下文
    * @param params 传入参数
    */
    private async executePrepareparam2(context:any,params:any,isloading:boolean){
        // 准备参数节点
        Object.assign(params,{tymc:params.tymc});
        Object.assign(params,{tynr:params.tynr});
        return params;
    }


}